<script lang="ts">
  import { getSalseReportDateAPI } from "src/apis/get-sales-report-date";

  import { getSalseReportYearAPI } from "src/apis/get-sales-report-year";
  import { numberWithCommas } from "src/functions/comma-number";
import { convertDateTime, convertFullTime } from "src/functions/convert-time-th";

  import type { ReportModel, TableReportModel } from "src/models/report.type";
  import DateSelect from "src/widgets/DateSelect.svelte";

  import Bar from "svelte-chartjs/src/Bar.svelte";

  let options = {};
  let data = {};
  let year: string;
  let dataShowOnTable: TableReportModel[] = [];
  let dataShowOnTableDate: TableReportModel;
  let dateReport: string;
  let hideChart = false;

  async function setReportData() {
    hideChart = false;
    const reportData = await getSalseReportYearAPI(year);
    dataShowOnTable = reportData["tables"] || [];
    data = {
      labels: reportData["labels"] || [],
      datasets: reportData["datasets"] || [],
    };

    options = {
      responsive: true,
      scales: {
        xAxes: [
          {
            barPercentage: 1,
            gridLines: {
              display: true,
              color: "rgba(0, 0, 0, 0.1)",
            },
          },
        ],
        yAxes: [
          {
            gridLines: {
              display: true,
              color: "rgba(0, 0, 0, 0.1)",
            },
            ticks: {
              beginAtZero: true,
            },
          },
        ],
      },
    };
  }

  async function getReportByDate() {
    dataShowOnTableDate = await getSalseReportDateAPI(dateReport);
  }

  function printDiv() {
    const canvasReport: any = document.getElementById("barChart"); // เลือก div id ที่เราต้องการพิมพ์
    const chartImg = canvasReport.toDataURL();
    console.log("chartImg *** ", chartImg);
    hideChart = true;
    setTimeout(() => {
      const divToPrint: any = document.getElementById("salesChartReport"); // เลือก div id ที่เราต้องการพิมพ์
      const html = `<html>
      <head>
      <title>พิมพ์รายงานการขาย</title>
      <link href="https://fonts.googleapis.com/css?family=Sarabun&display=swap" rel="stylesheet">
      <link href="https://unpkg.com/tailwindcss@^2/dist/tailwind.min.css" rel="stylesheet">
      </head>
      <body onload="window.print();" onafterprint="window.close();">
        <img class="w-full p-2" src='${chartImg}'/>
        ${divToPrint.innerHTML} 
      </body>
      </html>`;
      const popupWin: any = window.open();
      popupWin.document.open();
      popupWin.document.write(html);
      popupWin.document.close();
      hideChart = false;
    }, 1000);
  }
</script>

<div class="w-full bg-gray-900 p-4 m-4 rounded">
  <div>
    <button on:click={printDiv} class="bg-yellow-400 text-white px-3 py-2"
      >พิมพ์/PDF</button
    >
  </div>
  <div id="salesChartReport">
    <div class="text-white">
      <p>รายงานการขาย</p>
    </div>
    <div class="flex w-full justify-end pr-3">
      <input
        bind:value={year}
        placeholder="ระบุปีที่ต้องการดู *2564"
        type="tel"
        maxlength="4"
        class="bg-white px-4 py-2"
      />
      <button on:click={setReportData} class="bg-blue-500 text-white px-4 py-2">
        ค้นหา
      </button>
    </div>

    {#if !hideChart}
      <Bar id="barChart" {data} {options} />
    {/if}

    {#if dataShowOnTable.length > 0}
      <div class="block w-full overflow-x-auto">
        <table
          class="table-auto w-full overflow-y-auto overflow-x-auto border rounded text-sm"
        >
          <thead class="bg-gray-100">
            <tr>
              <th class="px-4 py-2">#</th>
              <th class="px-4 py-2">ปี</th>
              <th class="px-4 py-2">เดือน</th>
              <th class="px-4 py-2">ยอดรวมภายในเดือน (บาท)</th>
            </tr>
          </thead>
          {#each dataShowOnTable as bill, index}
            <tbody>
              <tr class="bg-gray-100 hover:bg-gray-200">
                <td class="border px-2 py-2 text-gray-800">{index + 1}</td>
                <td class="border px-2 py-2 text-gray-800">{bill["year"]}</td>
                <td class="border px-2 py-2 text-gray-800">{bill["month"]}</td>
                <td
                  class="border px-2 py-2 text-center font-bold text-green-500"
                  >{numberWithCommas(+bill["sum"])}</td
                >
              </tr>
            </tbody>
          {/each}
        </table>
      </div>
    {/if}

    <div class="block w-full overflow-x-auto">
      <div class="flex justify-end m-2 px-2 items-center">
        <p class="text-white">ดูรายวัน :</p>
        <DateSelect customClass="px-4 py-2" bind:dateString={dateReport} />
        <button
          on:click={getReportByDate}
          class="bg-blue-500 text-white px-4 py-2 border border-blue-100"
        >
          ค้นหา
        </button>
      </div>
      <div class="flex p-3 text-gray-900 justify-end">
        {#if dateReport && dataShowOnTableDate && Object.values(dataShowOnTableDate).length}
          <div class="flex flex-col bg-yellow-400 rounded p-3 m-3">
            {convertDateTime(`${dataShowOnTableDate["month"]}/${dataShowOnTableDate["date"]}/${dataShowOnTableDate["year"]}`)}
            ยอดรวมรายวัน: {numberWithCommas(dataShowOnTableDate["sum"])} บาท
          </div>
        {/if}
      </div>
    </div>
  </div>
</div>
